%% Copyright (c) 2013- Thomas Allen <thomas@oinksoft.com>
%%
%% Permission is hereby granted, free of charge, to any person obtaining
%% a copy of this software and associated documentation files (the
%% "Software"), to deal in the Software without restriction, including
%% without limitation the rights to use, copy, modify, merge, publish,
%% distribute, sublicense, and/or sell copies of the Software, and to
%% permit persons to whom the Software is furnished to do so, subject to
%% the following conditions:
%%
%% The above copyright notice and this permission notice shall be
%% included in all copies or substantial portions of the Software.
%%
%% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
%% EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
%% MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
%% NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
%% BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
%% ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
%% CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
%% SOFTWARE.

%% @doc Test variable filter mechanism.
-module(dtl_filter_tests).

-include("test.hrl").
-include_lib("eunit/include/eunit.hrl").

%% Test that filters work properly (depends on `dtl_library_tests' to
%% be sure that we can load the test library).
basic_filter_test_() ->
    Tests = [{<<"PIG">>, <<"{{ \"pig\"|upper }}">>},
             {<<" 1c2o3w ">>, <<" {{ \"1C2O3w\" | lower }} ">>},
             {<<"PIG">>, <<"{{ \"PIG\"|lower|upper }}">>}],
    ?COMPARE_TEMPLATES(Tests, dtl_context:new()).
